"use strict";
let btnSubmit = document.querySelector("#btnEnviar");

//btnSubmit.disabled = true;

let formDisabled = true;

let validState = {
  nombreComercio: false,
  numeroCertificado: false,
  alias: false,
  digitoVerificador: false,
  keysource: false,
  razonSocial: false,
  cuentaClabe: false,
  institucionBancaria: false,
  rfc: false,
  giroEmpresa: false,
  telefono: false,
  emailUser: false,
  terms: false,
};

const activeBtn = () => {
  validState.nombreComercio &&
  validState.numeroCertificado &&
  validState.alias &&
  validState.digitoVerificador &&
  validState.keysource &&
  validState.razonSocial &&
  validState.cuentaClabe &&
  validState.institucionBancaria &&
  validState.rfc &&
  validState.giroEmpresa &&
  validState.telefono &&
  validState.emailUser &&
  validState.terms
    ? (formDisabled = false)
    : (formDisabled = true);
};

/*
const activeBtn = () => {
  validState.nombreComercio &&
  validState.numeroCertificado &&
  validState.alias &&
  validState.digitoVerificador &&
  validState.keysource &&
  validState.razonSocial &&
  validState.cuentaClabe &&
  validState.institucionBancaria &&
  validState.rfc &&
  validState.giroEmpresa &&
  validState.telefono &&
  validState.emailUser &&
  validState.terms
    ? (btnSubmit.disabled = false)
    : (btnSubmit.disabled = true);
};
*/

const validInputText = (id, condition) => {
  const input = document.querySelector(`#${id}`);
console.log(id, condition);
  const errorMessage = document.getElementsByTagName("span").namedItem(id);
  if (input.value.length < condition) {
    input.classList.add("error");
    errorMessage.innerHTML = "El campo es obligatorio";
    errorMessage.classList.add("error_message");
    Object.defineProperty(validState, id, { value: false });
  } else {
    input.classList.remove("error");
    errorMessage.innerHTML = "";
    errorMessage.classList.remove("error_message");
    Object.defineProperty(validState, id, { value: true });
  }
  activeBtn();
};



  

const validEmail = (id) => {
  const input = document.querySelector(`#${id}`);
  const errorMessage = document.getElementsByTagName("span").namedItem(id);
  if (
    !/^(([^<>()\[\]\\.,;:\s@"]+(\.[^<>()\[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/i.test(
      input.value
    )
  ) {
    input.classList.add("error");
    errorMessage.innerHTML = "Intruduce un email con formato valido";
    errorMessage.classList.add("error_message");
    validState.emailUser = false;
    Object.defineProperty(validState, id, { value: false });
  } else {
    input.classList.remove("error");
    errorMessage.innerHTML = "";
    errorMessage.classList.remove("error_message");
    validState.emailUser = true;
    Object.defineProperty(validState, id, { value: true });
  }

  activeBtn();
};


const validClabe = (id) => {
  const input = document.querySelector(`#${id}`);
  const errorMessage = document.getElementsByTagName("span").namedItem(id);
  
  let resultado = /^[0-9]{18}$/.test(input.value);
  despliegaResultadoCampo(id, resultado, "Intruduce una cuenta CLABE con formato valido");
  activeBtn();
};

const validTelefono = (id) => {
  const input = document.querySelector(`#${id}`);
  const errorMessage = document.getElementsByTagName("span").namedItem(id);
  
  let resultado = /^[0-9]{10}$/.test(input.value);
  despliegaResultadoCampo(id, resultado, "El telefóno debe de ser a 10 dígitos");
  activeBtn();
};

const despliegaResultadoCampo = (id, resultado, mensaje) => {
    
    
  const input = document.querySelector(`#${id}`);
  const errorMessage = document.getElementsByTagName("span").namedItem(id);
  
  
  
    if (resultado) {
    input.classList.remove("error");
    errorMessage.innerHTML = "";
    errorMessage.classList.remove("error_message");
    validState.emailUser = true;
    Object.defineProperty(validState, id, { value: true });
  } else {
     input.classList.add("error");
    errorMessage.innerHTML = mensaje;
    errorMessage.classList.add("error_message");
    validState.emailUser = false;
    Object.defineProperty(validState, id, { value: false });
    
  }
    
}

const validarInputRFC = (id) => {
    let input =     document.querySelector(`#${id}`);
    const errorMessage = document.getElementsByTagName("span").namedItem(id);
    
    var rfc         = input.value.trim().toUpperCase()
        
    var rfcCorrecto = rfcValido(rfc);   // ⬅️ Acá se comprueba
  
    if (rfcCorrecto) {
    	input.classList.remove("error");
        errorMessage.innerHTML = "";
        errorMessage.classList.remove("error_message");
        validState.emailUser = true;
    Object.defineProperty(validState, id, { value: true });
    } else {
    	input.classList.add("error");
        errorMessage.innerHTML = "Intruduce un RFC con formato valido";
        errorMessage.classList.add("error_message");
        validState.emailUser = false;
        Object.defineProperty(validState, id, { value: false });
    }
    
     activeBtn();
}




const rfcValido = (rfc, aceptarGenerico = true) => {
    const re       = /^([A-ZÑ&]{3,4}) ?(?:- ?)?(\d{2}(?:0[1-9]|1[0-2])(?:0[1-9]|[12]\d|3[01])) ?(?:- ?)?([A-Z\d]{2})([A\d])$/;
    var   validado = rfc.match(re);

    if (!validado)  //Coincide con el formato general del regex?
        return false;

    //Separar el dígito verificador del resto del RFC
    const digitoVerificador = validado.pop(),
          rfcSinDigito      = validado.slice(1).join(''),
          len               = rfcSinDigito.length,

    //Obtener el digito esperado
          diccionario       = "0123456789ABCDEFGHIJKLMN&OPQRSTUVWXYZ Ñ",
          indice            = len + 1;
    var   suma,
          digitoEsperado;

    if (len == 12) suma = 0
    else suma = 481; //Ajuste para persona moral

    for(var i=0; i<len; i++)
        suma += diccionario.indexOf(rfcSinDigito.charAt(i)) * (indice - i);
    digitoEsperado = 11 - suma % 11;
    if (digitoEsperado == 11) digitoEsperado = 0;
    else if (digitoEsperado == 10) digitoEsperado = "A";

    //El dígito verificador coincide con el esperado?
    // o es un RFC Genérico (ventas a público general)?
    if ((digitoVerificador != digitoEsperado)
     && (!aceptarGenerico || rfcSinDigito + digitoVerificador != "XAXX010101000"))
        return false;
    else if (!aceptarGenerico && rfcSinDigito + digitoVerificador == "XEXX010101000")
        return false;
    return rfcSinDigito + digitoVerificador;
}




const validCheck = () => {
  let input = document.querySelector(`#flexCheckDefault`);

  if (input.checked) {
    validState.terms = true;
  } else {
    validState.terms = false;
  }
  console.log(validState);
  activeBtn();
};


const iniciarValidaciones = () => {
    
    const camposValidar = [
        {id:"nombreComercio", l: 3},
        {id:"numeroCertificado", l: 2},
        {id:"digitoVerificador", l: 2},
        {id:"alias", l: 3},
        {id:"keysource", l: 2},
        {id:"razonSocial", l: 5},
        {id:"cuentaClabe", l: 18},
        {id:"institucionBancaria", l: 3},
        {id:"rfc", l: 10},
        {id:"giroEmpresa", l: 2},
        {id:"telefono", l: 10},
        {id:"emailUser", l: 10}
        ];
        
        
 document.getElementById("flexCheckDefault").addEventListener("click", validCheck);
    
  /*  
     oninput="validInputText('',1)"
     oninput="validInputText('nombreComercio',3)"
     oninput="validInputText('alias',3)"
      oninput="validInputText('keysource',2)"
      oninput="validInputText('razonSocial',5)"
      oninput="validInputText('cuentaClabe',5)"
      oninput="validInputText('institucionBancaria',3)"
      oninput="validInputText('rfc',10)"
      oninput="validInputText('giroEmpresa',3)"
       oninput="validInputText('telefono',10)"
        oninput="validEmail('emailUser')"
         onchange="validCheck()"
        */
 
    camposValidar.forEach(element => {
        
       // console.log(element);
        document.getElementById(element.id).addEventListener("input", () => {
            
            
            switch (element.id) {
                
                case "emailUser" : 
                    
    //                console.log("validado emailUser");
      //              console.log(element.id);
                    validEmail (element.id);
                    break; 
                    
                case "cuentaClabe" : 
                        validClabe("cuentaClabe"); 
                 break; 
                        
                case "rfc" : 
                        validarInputRFC("rfc"); 
                        
                break; 
                
                
                case "telefono" : 
                        validTelefono("telefono"); 
                        
                break; 
                
                
                default : 
                    console.log("validado otros: "+element.id);
                    validInputText(element.id,element.l);
                
                break; 
                
            }
            
        });
        
        
    }
    );
    
    
    
}

iniciarValidaciones();

